package aimas2014.search.instantiations;

import massim.javaagents.agents.MarsUtil;
import aimas2014.search.MarsSearchNode;
import aimas2014.search.SearchNodeType;
import aimas2014.search.actions.ActionType.InstantiatedAction;
import eis.iilang.Action;

public class InstantiatedSurveyAction extends InstantiatedAction {
    @Override
    public Action realize() {
        return MarsUtil.surveyAction();
    }

    @Override
    public SearchNodeType apply(SearchNodeType s) {
    	return ((MarsSearchNode) s.copy()).step().cost(1).surveyed();
    }

    @Override
    public int hashCode() {
        return "survey".hashCode();
    }
    
    @Override
    public boolean equals(Object obj) {
    	return obj instanceof InstantiatedSurveyAction;
    }

	@Override
	public boolean isApplicable(SearchNodeType s) {
		MarsSearchNode fromNode = (MarsSearchNode) s;
		
		return !fromNode.nodeSurveyed && fromNode.currentEnergy >= 1;
	}
}